<?php

	class IM_Adapted extends Image_Adapter {
		
		private $_im;
		private $_current;
		private $_width;
		private $_height;
        private $_format;
			
		public function create_image($image, $format = 'jpg') {
			$this->_im = new Imagick();
			#$this->_im->readImageBlob(file_get_contents($image));

			$this->_im->readImageBlob($image);
            if($format == 'png') {
                $this->_im->setImageFormat('png');
            } elseif($format == 'jpg' || $format == 'jpeg') {
                $this->_im->setImageFormat('jpeg');
            } elseif($format == 'gif') {
                $this->_im->setImageFormat('gif');
            }

			$this->_width = $this->_im->getImageWidth();
			$this->_height = $this->_im->getImageHeight();
            $this->_format = $format;
			
			return true;
		}
		
		public function get_width() {
			return $this->_im->getImageWidth();
		}
		
		public function get_height() {
			return $this->_im->getImageHeight();
		}
		
		public function crop($start_x, $start_y, $width = 'auto', $height = 'auto') {

            $this->_im->setImagePage(0,0,0,0);

			$width = $width == 'auto' ? $this->get_width()-$start_x : $width;
			$height = $height == 'auto' ? $this->get_height()-$start_y : $height;

            $this->_im->cropImage($width, $height, $start_x, $start_y);
		}
		
		public function resize($width, $height, $type = 'minimal') {
			$new_max_width = $thumb_width = $width;
			$new_max_height = $thumb_height = $height;
			
			$source_ratio = $this->_width / $this->_height;
			$thumb_ratio = $new_max_width / $new_max_height;
			
			if( $this->_width <= $new_max_width && $this->_height <= $new_max_height ) {
				$thumb_width = $this->_width;
				$thumb_height = $this->_height;
			} else {
				
				if($type == 'minimal') {
					if( $thumb_ratio > $source_ratio ) {
						$thumb_width = (int)($source_ratio*$new_max_height);
						$thumb_height = $new_max_height;
					} else {
						$thumb_width = $new_max_width;
						$thumb_height = (int)(($this->_height / $this->_width)*$new_max_width);
					}
				} else {
					if( $thumb_ratio < $source_ratio ) {
						$thumb_width = (int)($source_ratio*$new_max_height);
						$thumb_height = $new_max_height;
					} else {
						$thumb_width = $new_max_width;
						$thumb_height = (int)(($this->_height / $this->_width)*$new_max_width);
					}
				}
			
			}
			
			$this->_im->resizeImage((int)$thumb_width, (int)$thumb_height, Imagick::FILTER_LANCZOS, 0.9, true);
		}

		public function scale( $percent ){
			$new_width  = $this->get_width() * $percent;
			$new_height = $this->get_height() * $percent;

			$this->_im->scaleImage( $new_width, $new_height ); 
		}
		
		public function generate($quality) {

            if($this->_format == 'png') {
                $this->_im->setCompression(Imagick::COMPRESSION_LZW);
                $this->_im->setImageCompressionQuality(1);
            } elseif($this->_format == 'jpg') {
                $this->_im->setCompression(Imagick::COMPRESSION_JPEG);
                $this->_im->setImageCompressionQuality($quality);
            } elseif($this->_format == 'gif') {
                $this->_im->setCompression(Imagick::COMPRESSION_UNDEFINED);
                $this->_im->setImageCompressionQuality(0);
            }

			ob_start();
			echo $this->_im;
			$content = ob_get_contents();
			ob_end_clean();
			
			return $content;
		}
		
	}