<?php
	require_once dirname( __FILE__ ) . '/../lib/Storage_Adapter.php';
	require_once dirname( __FILE__ ) . '/../external/S3.php';
	
	class S3_Adapter extends Storage_Adapter {
		
		private $_s3 = null;
		private $_bucket = null;
		
		public function __construct($access_key, $secret_key, $bucket = 'imenginex') {
			
			$this->_bucket = $bucket;
			$this->_s3 = new S3($access_key, $secret_key);
		}
		
		public function store($filename, $content) {
			$this->_s3->putObject($content, $this->_bucket, $filename, S3::ACL_PUBLIC_READ, array(), 'image/jpeg');
		}
		
		public function load($filename) {
			$resp = @$this->_s3->getObject($this->_bucket, $filename);
			
			if($resp) {
				return $resp->body;
			} else {
				return null;
			}
			
		}

		public function listBuckets(){
			return $this->_s3->listBuckets();
		}
		
	}
