<?php

class FrontCacheFlusher {

	public function __construct() {
		//Notifier Flush
		add_action( 'oc_event_listener_post_purge', array( &$this, 'every_frontcache_flush' ), 1, 1 );

		//Widget Saved Flush
		add_action( 'every_widget_saved_flush', array( &$this, 'every_frontcache_flush' ), 1, 1 );

		//Board altered Flush
		add_action( 'board_changed_hook', array( &$this, 'every_frontcache_flush' ), 1, 1 );
	}

	/*
	 * Function to Flush Mem-cache / batcache static HTML cache
	 * Register cache flush listeners
	 * Will flush cache on memcahed/APC when widgets are saved
	 * And on notification from OC Notifier
	 */
	public function every_frontcache_flush( $post_id ) {

		global $batcache;
		if ( ! function_exists( 'batcache_clear_url' ) ) {
			require_once( WP_CONTENT_DIR . '/advanced-cache.php' );
			require_once( WP_CONTENT_DIR . '/plugins/batcache.php' );
		}

		$front_id = get_option( 'page_on_front' );

		if ( $front_id === $post_id ) {
			batcache_clear_url( get_option( 'home' ) );
			batcache_clear_url( trailingslashit( get_option( 'home' ) ) );
		}

		batcache_clear_url( get_permalink( $post_id ) );
		do_action( 'every_frontcache_flush_hook', $post_id, $front_id );
	}

}