<?php

class OcObjectsCollection {

	private $json;

	private $total_hits;

	private $article_collection = array();
	private $image_collection = array();
	private $ad_collection = array();

	public function __construct() {

	}

	/*
	 * Public function to fill collections with objects
	 * @param AbstractOcObject Object
	 * @return -
	 */
	public function ad_object_to_collection( AbstractOcObject $object ) {
		$object_type = get_class( $object );

		switch ( $object_type ) {
			case 'OcArticle':
				array_push( $this->article_collection, $object );
				break;
			case 'OcImage':
				array_push( $this->image_collection, $object );
				break;
			case 'OcAd':
				array_push( $this->ad_collection, $object );
				break;
		}

		$this->total_hits ++;
	}

	/*
	 * Public function to set json
	 * $param json
	 * @return -
	 */
	public function set_json( $json ) {
		$this->json = $json;
	}

	/*
	 * Public function to get all json
	 * @param -
	 * @return json
	 */
	public function get_json() {
		return $this->json;
	}

	/*
	 * Public function to get total hits
	 * @param -
	 * @return int total hits
	 */
	public function get_total_hits() {
		return $this->total_hits;
	}

	/*
	 * Public function to get all oc_articles
	 * @param -
	 * @return article-array
	 */
	public function articles() {
		return $this->article_collection;
	}

	/*
	 * Public function to get all oc_images
	 * @param -
	 * @return image-array
	 */
	public function images() {
		return $this->image_collection;
	}

	/*
	 * Public function to get all oc_ads
	 * @param -
	 * @return ad-array
	 */
	public function ads() {
		return $this->ad_collection;
	}
}